#!/usr/bin/perl -w
#fastUpdate.pl - rapdily scan memory, interrupts and processes
use strict;
my $lastEthInt = 0;
my $lastProc = 0;

while(1){
  # compute 0-100 scale of memory free based on "average" system load and 256MB
  # ram
  my $res = `cat /proc/meminfo |grep MemFree `;
  my( undef, $memFree ) = split " ", $res; 
  if( $memFree > 70000 ){ $memFree = 70000 }
  $memFree = sprintf("%0.0f", $memFree/ 700);
  $memFree = 100 - $memFree;

  # compute 0-100 scale of ethernet interrupts based > 1000 equivalent to 
  # near network link saturation
  $res = `cat /proc/interrupts | grep eth1`;
  my( undef, $ethInter ) = split " ", $res;
  if( $lastEthInt == 0 ){
    $lastEthInt = $ethInter;
    $ethInter = 0;
  }else{
    my $diffInt = $ethInter - $lastEthInt;
    $lastEthInt = $ethInter;
    $ethInter = $diffInt;
  }
  if( $ethInter > 1000 ){ $ethInter = 1000 }
  $ethInter = sprintf("%0.0f", $ethInter / 10);

  # compute 0-100 scale of recently created processes 
  $res = `cat /proc/stat | grep processes`;
  my( undef, $proc ) = split " ", $res;
  if( $lastProc == 0 ){
    $lastProc = $proc;
    $proc = 0;
  }else{
    my $diffProc = $proc - $lastProc;
    $lastProc = $proc;
    $proc = $diffProc;
  }
  if( $proc > 100 ){ $proc = 100 }

  print "$memFree $ethInter $proc\n";
  # sub second sleep
  select(undef, undef, undef, $ARGV[0]);

}#infinite loop
